<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
</head>
<body>
    <script>
//WeakMap
    // khởi tạo weakmap
    var weak = new WeakMap();

    var key1={};
    var key2={};
    weak.set(key1, "Javascript nâng cao")
    weak.set(key2, "Tiến trình học đang là ES6")
    // lấy giá trị trong weakmap
    console.log(weak.get(key1))
    console.log(weak.get(key2))
    //kiểm tra tồn tại trong weakemap
    console.log(weak.has(key1))
    // console.log(weak.has(key_other))// error
    // xóa phần tử trong weakmap
    weak.delete(key1)
    console.log(key1)

//WeakSet
var weakset = new WeakSet();

    var key3={ name :'google'};
    var key4={ website: 'google.com'};
    weakset.add(key3);
    weakset.add(key4);
    //kiểm tra tồn tại trong weakemap
    console.log(weakset.has(key3))
    console.log(weakset)
    // console.log(weak.has(key_other))// error
    // xóa phần tử trong weakmap
    weakset.delete(key3)
    console.log(key3)
    </script>
</body>
</html>